/*
(c) Janusz Ganczarski
http://www.januszg.hg.pl
JanuszG@enter.net.pl
*/

// rozmiar tablicy z mask filtra

#define FILTER_SIZE 9

// uchwyt tekstury dwuwymiarowej

uniform sampler2D tex;

// rozmiary tekstury dwuwymiarowej

uniform float width;
uniform float height;

// maska filtra 3x3

uniform float filter [FILTER_SIZE];

void main ()
{
    // obliczenie przesunicia wsprzdnych tekstury 
    // odpowiadajcych pojedynczemu tekselowi
    float step_w = 1.0/width;
    float step_h = 1.0/height;

    // tablica wartoci przesunicia wsprzdnych tekstur
    // w celu pobrania wybranych elementw tekstury
    vec2 offset [FILTER_SIZE];
    offset [0] = vec2 (-step_w,-step_h);
    offset [1] = vec2 (0.0,-step_h);
    offset [2] = vec2 (step_w,-step_h);
    offset [3] = vec2 (-step_w,0.0);
    offset [4] = vec2 (0.0,0.0);
    offset [5] = vec2 (step_w,0.0);
    offset [6] = vec2 (-step_w,step_h);
    offset [7] = vec2 (0.0,step_h);
    offset [8] = vec2 (step_w,step_h);

    // pocztkowy kolor wynikowy operacji filtracji
    vec4 sum = vec4 (0.0);

    // obliczenie wartoci skadowych teksela po filtracji
    for (int i = 0; i < FILTER_SIZE; i++)
        sum += texture2D (tex,gl_TexCoord [0].st + offset [i]) * filter [i];

    // obliczenie skadowych koloru wynikowego fragmentu
    gl_FragColor = sum;
}
