/*
(c) Janusz Ganczarski
http://www.januszg.hg.pl
JanuszG@enter.net.pl
*/

// znormalizowany wektor normalny we wsprzdnych obserwatora

varying vec3 N;

// wsprzdne biecego wierzchoka

varying vec3 V;

// znormalizowany wektor kierunku rda wiata

varying vec3 L;

// skadowe wiata rozproszonego, otaczajcego
// i odbitego (bez wykadnika rozbysku)

varying vec4 diffuse,ambient,global_ambient,specular;

// wykadnik rozbysku wiata

varying float shininess;

// odlego biecego wierzchoka od pooenia rda wiata

varying float distance;

void main ()
{
    // przeksztacenie wektora normalnego gl_Normal do wsprzdnych ukadu obserwatora
    // przy uyciu macierzy gl_NormalMatrix; jest to standardowe przeksztacenie
    // klasycznego potoku OpenGL; otrzymany rezultat jest normalizowany
    N = normalize (gl_NormalMatrix * gl_Normal);

    // przeksztacenie biecego wierzchoka do wsprzdnych ukadu obserwatora
    V = vec3 (gl_ModelViewMatrix * gl_Vertex);

    // normalizacja wektora kierunku wiata; zakadamy, e mamy wiato
    // kierunkowe, std gl_LightSource[0].position zawiera wektor kierunku wiata
    L = normalize (gl_LightSource[0].position.xyz - V);

    // obliczenie odlegoci biecego wierzchoka od pooenia rda wiata
    distance = length (gl_LightSource[0].position.xyz - V);

    // obliczenie skadowych wiata rozproszonego
    diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;

    // obliczenie skadowych wiata otaczajcego
    ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;

    // obliczenie skadowych globalnego wiata otaczajcego
    global_ambient = gl_LightModel.ambient * gl_FrontMaterial.ambient;

    // obliczenie wiata odbitego (bez wykadnika rozbysku)
    specular = gl_FrontMaterial.specular * gl_LightSource[0].specular;

    // obliczenie wykadnika rozbysku wiata
    shininess = gl_FrontMaterial.shininess;

    // standardowe przeksztacenie wierzchokw
    gl_Position = ftransform ();
}
