/*
(c) Janusz Ganczarski
http://www.januszg.hg.pl
JanuszG@enter.net.pl
*/

// interpolowany wektor normalny we wsprzdnych obserwatora

varying vec3 N;

// interpolowany wektor powkowy

varying vec3 H;

// interpolowane skadowe wiata rozproszonego, 
// otaczajcego i odbitego (bez wykadnika rozbysku)

varying vec4 diffuse,ambient,specular;

// interpolowany wykadnik rozbysku wiata

varying float shininess;

void main ()
{
    // normalizacja interpolowanego wektora normalnego
    N = normalize (N);

    // normalizacja wektora kierunku wiata; zakadamy, e mamy wiato
    // kierunkowe, std gl_LightSource[0].position zawiera wektor kierunku wiata
    vec3 L = normalize (vec3 (gl_LightSource[0].position));

    // obliczenie cosinusa kta pomidzy wektorem normalnym a wektorem
    // kierunku wiata; poniewa oba wektory s jednostkowe ich iloczyn
    // skalarny jest rwny poszukiwanemu cosinusowi
    float NdotL = max (dot (N,L),0.0);

    // obliczenia zwizane ze wiatem odbitym i rozproszonym 
    // wykonywane s tylko dla owietlonych powierzchni
    if (NdotL > 0.0)
    {
        // normalizacja wektora powkowego i obliczenie cosinusa
        // kta pomidzy wektorem normalnym a wektorem powkowym
        float NdotH = max (dot (N,normalize (H)),0.0);

        // obliczenie wartoci skadowych wiata odbitego
        specular = specular * pow (NdotH,shininess);

        // dodanie wartoci skadowych wiata rozproszonego
        specular = specular + diffuse * NdotL;
    }
    else
        // warto skadowych wiata odbitego i rozproszonego dla nieowietlonej powierzchni
        specular = vec4 (0.0);

    // kocowe obliczenie skadowych koloru fragmentu
    gl_FragColor = ambient + specular;
}

